﻿// CSV Report Generator for SQL
// Copyright (C) 2010 Perry Curt Day II

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

using System;
using System.Collections.Generic;
using System.Text;

namespace CSVReportGenerator
{
    [Serializable]
    class Report
    {
        private string title, author, description, sqlConnectionString, sqlQuery;
        private DateTime created, modified;

        internal string Title
        {
            get { return title; }
            set { title = value; }
        }

        internal string Author
        {
            get { return author; }
            set { author = value; }
        }

        internal DateTime Created
        {
            get { return created; }
            set { created = value; }
        }

        internal DateTime Modified
        {
            get { return modified; }
            set { modified = value; }
        }

        internal string Description
        {
            get { return description; }
            set { description = value; }
        }

        internal string SqlConnectionString
        {
            get { return sqlConnectionString; }
            set { sqlConnectionString = value; }
        }

        internal string SqlQueryString
        {
            get { return sqlQuery; }
            set { sqlQuery = value; }
        }

        internal Report() { }

        internal Report(string title, string author, DateTime created, DateTime modified, string description, string sqlConnectionString, string sqlQuery)
        {
            this.title = title;
            this.author = author;
            this.created = created;
            this.modified = modified;
            this.description = description;
            this.sqlConnectionString = sqlConnectionString;
            this.sqlQuery = sqlQuery;
        }
    }
}
